<template>
  <div style="margin: 3rem">
   <header style="margin:10rem 6rem 3rem 6rem">
      <ReturnButton :offsetArrow="21" :spanTitle="2" title="Regresar" v-on:clickEvent="returnPage" style="margin-bottom:2.5rem"></ReturnButton>
    </header>
    <!-- COMPONENTE TITULO -->
    <div style="margin:3rem 6rem 0rem">
      <app-title :Title="title" bgColor="background-color: #4A4A4A !important"> </app-title>
    </div> 

   <el-main style="margin:3rem 6rem 0rem; min-height: 300px">
      <el-row v-if="isNotContent" v-loading="loading" :element-loading-text="loadingText">
        <el-col :span="24" style="display: flex; justify-content: center;" v-show="!loading">
          <img src="../../../../assets/images/no-materiales.svg">
        </el-col>
      </el-row>
      <el-row type="flex" style="flex-wrap: wrap" v-else>
        <el-col class="text-center with-cards" style="padding: 10px 50px 50px;" v-for="(item, index) in contentCards" :key="index" v-show="item.isShow == true && conditionalShow(item.instance)">
          <app-cardReviewHome
            @goTo="changeView(item.name, item.name.toUpperCase())"
            :titleTop="true" :textTop="item.name" 
            :titleBottom="false" 
            :styleTitleTop="item.colorTitle" 
            :colorCaret="item.colorCaret"
            :rutaImg="require(`@/assets/images/${item.routeImg}`)"
            :isBigLetters="item.isBigLetters"
            :styleCard="item.styleCard">
          </app-cardReviewHome>
        </el-col>
      </el-row>
    </el-main>
    
  </div>
</template>

<script>
// @ is an alias to /src
import ReturnButton from '@/components/ReturnButton.vue'
import cardReviewHome from '@/components/cardReviewHome.vue'
import Title from '@/components/Title.vue'
import { HTTP } from '../../../../main.js'
import { contentCardsData } from '@/enums.js'

export default {
  components: {
    'app-cardReviewHome': cardReviewHome,
    'app-title': Title,
     ReturnButton
  },
  data () {
    return {
      title:'SOPORTE DE MATERIALES NACIONALES',
      novelsCount: 0,
      cartoonsCount: 0,
      seriesCount: 0,
      specialsCount: 0,
      /*Add new cards*/
      movCount: 0,
      minCount: 0,
      cookCounter: 0,
      comicCounter: 0,
      deportCounter: 0,
      entertainmentCounter: 0,
      interviewCounter: 0,
      childCounter: 0,
      magazineCounter: 0,
      microprogramCounter: 0,
      periodisticoCounter: 0,
      programEspecialCounter: 0,
      religiousCounter: 0,
      talkshowCounter: 0,
      electoralCounter: 0,
      femaleCounter: 0,
      politicalCounter: 0,
      televisaNovel: 0,
      televisaSerie: 0,
      televisaSpecial: 0,
      loading: true,
      loadingText: 'Cargando Materiales Nacionales...',
      typeOfMaterial: 'Producción Nacional',
      contentCards: contentCardsData
    }
  },
  created () {
    
    contentCardsData.forEach((e, i) => {
      this.getMaterial(e.name, e.instance)
    })
  },
  computed: {
    multiplerFilter() {
      const array = [
        this.movCount,
        this.novelsCount,
        this.seriesCount,
        this.minCount,
        this.cartoonsCount,
        this.specialsCount,
        this.cookCounter,
        this.comicCounter,
        this.deportCounter,
        this.entertainmentCounter,
        this.interviewCounter,
        this.childCounter,
        this.magazineCounter,
        this.microprogramCounter,
        this.periodisticoCounter,
        this.programEspecialCounter,
        this.religiousCounter,
        this.talkshowCounter,
        this.electoralCounter,
        this.femaleCounter,
        this.politicalCounter
      ].join()
      return array
    },
    isNotContent() {
      if(
        this.movCount == 0 &&
        this.novelsCount == 0 &&
        this.seriesCount == 0 &&
        this.minCount == 0 &&
        this.cartoonsCount == 0 &&
        this.specialsCount == 0 &&
        this.cookCounter== 0 &&
        this.comicCounter== 0 &&
        this.deportCounter== 0 &&
        this.entertainmentCounter== 0 &&
        this.interviewCounter== 0 &&
        this.childCounter== 0 &&
        this.magazineCounter== 0 &&
        this.microprogramCounter== 0 &&
        this.periodisticoCounter== 0 &&
        this.programEspecialCounter== 0 &&
        this.religiousCounter== 0 &&
        this.talkshowCounter== 0 &&
        this.electoralCounter== 0 &&
        this.femaleCounter == 0 &&
        this.politicalCounter == 0
      ) {
        return true
      } else {
        return false
      }
    }
  },
  methods: {
    getMaterial(material, value){
      HTTP.get('materials/materialType/'+this.typeOfMaterial+'/typeOfContent/'+material+'/canned/false')
      .then(res => {
        console.log(res.data.count, 'res.data.count')
        this[value] = res.data.count
        if (res.data.count == 0) {
          this.loading = false
        }
      })
      .catch(err => {
        console.log(err);
      });
    },
    returnPage () {
      this.$router.push({ name: 'support'})
    },
    changeView (typeMaterialSelected) {
      this.$localStorage.set('typeMaterialR', this.typeOfMaterial)
      this.$localStorage.set('typeContentSupport', typeMaterialSelected)
      this.$router.push({ name: 'nationalProduction' })
    },
    conditionalShow(value) {
      return this[value] > 0 ? true : false
    }
  },
  watch: {
    multiplerFilter(val) {
      if(
        this.contadorNovelas !== 0 &&
        this.contadorSeries !== 0 &&
        this.contadorSpeciales !== 0 &&
        this.contadorDibujos !== 0 &&
        this.contadorMiniseries !== 0 &&
        this.contadorLargometrajes !== 0 &&
        this.cookCounter!== 0 &&
        this.comicCounter!== 0 &&
        this.deportCounter!== 0 &&
        this.entertainmentCounter!== 0 &&
        this.interviewCounter!== 0 &&
        this.childCounter!== 0 &&
        this.magazineCounter!== 0 &&
        this.microprogramCounter!== 0 &&
        this.periodisticoCounter!== 0 &&
        this.programEspecialCounter!== 0 &&
        this.religiousCounter!== 0 &&
        this.talkshowCounter!== 0 &&
        this.electoralCounter!== 0 &&
        this.femaleCounter !== 0 &&
        this.politicalCounter !== 0
      ) {
        this.loading = false
      } else {
        this.loading = true
      }
    }
  }
}
</script>
